local me = CreateFrame("frame")

AutoLootSpecSwap_bossNameToSpecMapping = {
}
AutoLootSpecSwap_specToSwitchToAfterLooting = 0
AutoLootSpecSwap_globalSilence = false

local autoSwapActive = false
local globalDisable = false
local journalSaveButton = CreateFrame("Button", "EncounterJournalEncounterFrameInfoCreatureButton1ALSSSaveButton",UIParent,"UIPanelButtonTemplate")
local journalForgetButton = CreateFrame("Button", "EncounterJournalEncounterFrameInfoCreatureButton1ALSSForgetButton",UIParent,"UIPanelButtonTemplate")
local journalDefaultButton = CreateFrame("Button", "EncounterJournalEncounterFrameInfoCreatureButton1ALSSDefaultButton",UIParent,"UIPanelButtonTemplate")
local f = CreateFrame("frame")

local origprint = print
local print = function(msg)
	if(not AutoLootSpecSwap_globalSilence) then
		origprint(msg)
	end
end

me:RegisterEvent("PLAYER_TARGET_CHANGED")
me:RegisterEvent("LOOT_CLOSED")
local UnitName = _G["UnitName"]
local UnitIsDead = _G["UnitIsDead"]
me:SetScript("OnEvent", function(self, event)
	if(globalDisable) then return end
	local newSpec = nil
	if(event == "PLAYER_TARGET_CHANGED") then
		if(not UnitIsDead("target")) then
			if(UnitIsEnemy("player","target")) then
				local targetName = UnitName("target")
				newSpec = AutoLootSpecSwap_bossNameToSpecMapping[targetName]
				if(newSpec) then
					inDefaultSpecAlready = false
					autoSwapActive = true
				end
			end
		end
	elseif(autoSwapActive and (not (inDefaultSpecAlready--[[ or InCombatLockdown()]]))) then
		autoSwapActive = false
		if(AutoLootSpecSwap_specToSwitchToAfterLooting ~= 0) then
			newSpec = AutoLootSpecSwap_specToSwitchToAfterLooting
			inDefaultSpecAlready = true
		end
	end
	if(newSpec and ((GetLootSpecialization()) ~= newSpec)) then
		if(newSpec == -1) then
			SetLootSpecialization(0)
			print("AutoLootSpecSwap: CHANGED LOOT SPEC TO FOLLOW CURRENT SPEC")
		else
			SetLootSpecialization(newSpec)
			print("AutoLootSpecSwap: CHANGED LOOT SPEC TO: <<"..(select(2,GetSpecializationInfoByID(newSpec)))..">>")
		end
	end
end)

local overrideTarget = nil
function me.SlashCommandHandler(cmd)
	if cmd and string.lower(cmd) == "record" then
		local currSpec = (GetLootSpecialization())
		local currTarget = overrideTarget or UnitName("target")
		
		if(type(currSpec) == "number" and type(currTarget) == "string") then
			if(currSpec == 0) then
				origprint("AutoLootSpecSwap: You must set a spec first (right-click your character frame).")
			else
				AutoLootSpecSwap_bossNameToSpecMapping[currTarget] = currSpec
				print("AutoLootSpecSwap: Recorded <<"..(select(2,GetSpecializationInfoByID(currSpec)))..">> as preferred spec for <<"..currTarget..">>.")
			end
		end
	elseif cmd and string.lower(cmd) == "setdefault" then
		local currSpec = (GetLootSpecialization())
		if(type(currSpec) == "number") then
			if(currSpec == 0) then
				AutoLootSpecSwap_specToSwitchToAfterLooting = -1
				print("AutoLootSpecSwap: Set default spec to follow your actual spec.")
			else
				AutoLootSpecSwap_specToSwitchToAfterLooting = currSpec
				print("AutoLootSpecSwap: Set default spec to <<"..(select(2,GetSpecializationInfoByID(currSpec)))..">>.")
			end
		end
	elseif cmd and string.lower(cmd) == "setdefaulttofollow" then
		AutoLootSpecSwap_specToSwitchToAfterLooting = -1
		print("AutoLootSpecSwap: Set default spec to follow your actual spec.")
	elseif cmd and string.lower(cmd) == "list" then
		print("AutoLootSpecSwap: List")
		for k,v in pairs(AutoLootSpecSwap_bossNameToSpecMapping) do
			if(type(v) == "number" and type(k) == "string") then
				print(k..": "..(select(2,GetSpecializationInfoByID(v))))
			end
		end
		if(AutoLootSpecSwap_specToSwitchToAfterLooting) then
			if(AutoLootSpecSwap_specToSwitchToAfterLooting == 0) then
				print("Default: <<No default>>")
			elseif(AutoLootSpecSwap_specToSwitchToAfterLooting == -1) then
				print("Default: <<Current Spec>>")
			else
				print("Default: "..(select(2,GetSpecializationInfoByID(AutoLootSpecSwap_specToSwitchToAfterLooting))))
			end
		end
	elseif cmd and string.lower(cmd) == "forget" then
		local currTarget = overrideTarget or UnitName("target")
		if(type(currTarget) == "string") then
			AutoLootSpecSwap_bossNameToSpecMapping[currTarget] = nil
			print("AutoLootSpecSwap: Forgot target <<"..currTarget..">>.")
		end
	elseif cmd and string.lower(cmd) == "forgetdefault" then
		AutoLootSpecSwap_specToSwitchToAfterLooting = 0
		print("AutoLootSpecSwap: Forgot default spec.")
	elseif cmd and string.lower(cmd) == "onff" then
		globalDisable = not globalDisable
		journalSaveButton:SetShown(not globalDisable)
		journalForgetButton:SetShown(not globalDisable)
		print("AutoLootSpecSwap: " .. ((not globalDisable) and "Enabled." or "Disabled."))
	elseif cmd and string.lower(cmd) == "quiet" then
		AutoLootSpecSwap_globalSilence = not AutoLootSpecSwap_globalSilence
		print("AutoLootSpecSwap: Unsilenced")
	else
		print("AutoLootSpecSwap: Usage:\n/alss record | setdefault | setdefaulttofollow | list | forget | forgetdefault | quiet | onff")
	end
end

journalSaveButton:SetScript("OnClick",function(self)
	overrideTarget = EncounterJournalEncounterFrameInfoCreatureButton1.name
	me.SlashCommandHandler("record")
	overrideTarget = nil
end)
journalForgetButton:SetScript("OnClick",function(self)
	overrideTarget = EncounterJournalEncounterFrameInfoCreatureButton1.name
	me.SlashCommandHandler("forget")
	overrideTarget = nil
end)
journalDefaultButton:SetScript("OnClick",function(self, button)
	if(button == "RightButton") then
		me.SlashCommandHandler("forgetdefault")
	else
		me.SlashCommandHandler("setdefault")
	end
end)
journalDefaultButton:RegisterForClicks("AnyDown")

journalSaveButton:SetWidth(320)
journalSaveButton:SetHeight(80)
journalSaveButton:SetPoint("CENTER",0,400)
journalSaveButton:SetText("Save <click a boss in the journal to start>\n(Right-click your portrait to select a loot spec)\n(Then select a boss and click here.)")
journalForgetButton:SetWidth(320)
journalForgetButton:SetHeight(50)
journalForgetButton:SetPoint("CENTER",0,400)
journalForgetButton:SetText("Delete: <click a boss in the journal to start> \n(Current: <none selected>)")
journalDefaultButton:SetWidth(320)
journalDefaultButton:SetHeight(80)
journalDefaultButton:SetPoint("CENTER",0,400)
journalDefaultButton:SetText("ALSS Default Loot Spec\n(Right-click your portrait to select a loot spec)\n(Left-click this button to set, right-click to clear)\n(Current: <none selected>)")

f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 32, edgeSize = 32,insets = { left = 11, right = 12, top = 12, bottom = 11 }})
f:SetBackdropColor(0,0,0,1)
f:SetFrameStrata("DIALOG")
f:SetToplevel(true)
f:EnableMouse(true)
f:SetMovable(true)
f:RegisterForDrag("LeftButton")
f:SetScript("OnDragStart", function(self) self:StartMoving() end)
f:SetScript("OnDragStop", function (self) self:StopMovingOrSizing() end)
f:SetWidth(400)
f:SetHeight(300)

local ttl = CreateFrame("frame", nil, f)
ttl:SetWidth(185)
ttl:SetHeight(40)
ttl:SetPoint("TOP", 0, 15)
ttl:SetFrameStrata("BACKGROUND")

ttl:EnableMouse(true)
ttl:RegisterForDrag("LeftButton")
ttl:SetScript("OnDragStart", function(self) self:GetParent():StartMoving() end)
ttl:SetScript("OnDragStop", function(self) self:GetParent():StopMovingOrSizing() end)

local ttx = ttl:CreateTexture(nil, "BACKGROUND")
ttx:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")
ttx:SetPoint("TOPRIGHT", 57, 0)
ttx:SetPoint("BOTTOMLEFT", -58, -24)

local ttlTxt = ttl:CreateFontString(nil, "OVERLAY", nil)
ttlTxt:SetFont("Fonts/MORPHEUS.ttf", 15)
ttlTxt:SetText("AutoLootSpecSwap")
ttlTxt:SetWidth(450)
ttlTxt:SetHeight(64)
ttlTxt:SetPoint("TOP", 0, 12)

journalSaveButton:SetParent(f)
journalSaveButton:ClearAllPoints()
journalSaveButton:SetPoint("TOP",f,"TOP",0,-25)
journalForgetButton:SetParent(f)
journalForgetButton:ClearAllPoints()
journalForgetButton:SetPoint("TOP",f,"TOP",0,-125)
journalDefaultButton:SetParent(f)
journalDefaultButton:ClearAllPoints()
journalDefaultButton:SetPoint("TOP",f,"TOP",0,-195)

f:Hide()

journalForgetButton:SetScript("OnUpdate",function(self)
	if(self:IsVisible()) then
		local bossName = EncounterJournalEncounterFrameInfoCreatureButton1.name
		
		if(type(bossName) == "string") then
			local bossSpec = AutoLootSpecSwap_bossNameToSpecMapping[bossName]
			journalSaveButton:SetText("Save selection for boss: '"..bossName.."'\n(Right-click your portrait to select a loot spec)\n(Then click here.)")
			if(type(bossSpec) == "number") then
				journalForgetButton:SetText("Delete selection for: '"..bossName.."'\n(Current: "..(select(2,GetSpecializationInfoByID(bossSpec)))..")")
			else
				journalForgetButton:SetText("Delete selection for: '"..bossName.."'\n(Current: <none selected>)")
			end
		end
		
		if(type(AutoLootSpecSwap_specToSwitchToAfterLooting) == "number") then
			if(AutoLootSpecSwap_specToSwitchToAfterLooting == 0) then
				journalDefaultButton:SetText("Default Loot Spec\n(Right-click your portrait to select a loot spec)\n(Left-click this button to set, right-click to clear)\n(Current: <none selected>)")
			elseif(AutoLootSpecSwap_specToSwitchToAfterLooting == -1) then
				journalDefaultButton:SetText("Default Loot Spec\n(Right-click your portrait to select a loot spec)\n(Left-click this button to set, right-click to clear)\n(Current: <go back to actual spec>)")
			else
				journalDefaultButton:SetText("Default Loot Spec\n(Right-click your portrait to select a loot spec)\n(Left-click this button to set, right-click to clear)\n(Current: "..(select(2,GetSpecializationInfoByID(AutoLootSpecSwap_specToSwitchToAfterLooting)))..")")
			end
		else
			journalDefaultButton:SetText("Default Loot Spec\n(Right-click your portrait to select a loot spec)\n(Left-click this button to set, right-click to clear)\n(Current: <none selected>)")
		end
	end
end)

SlashCmdList["AUTOLOOTSPECSWAP"] = me.SlashCommandHandler
SLASH_AUTOLOOTSPECSWAP1 = "/autolootspecswap"
SLASH_AUTOLOOTSPECSWAP2 = "/alss"

local loadframe = CreateFrame("frame")
loadframe:RegisterEvent("ADDON_LOADED")
loadframe:SetScript("OnEvent",function(self,event,addon)
	if(addon == "Blizzard_EncounterJournal") then
		f:SetParent(EncounterJournal)
		f:Show()
		f:ClearAllPoints()
		f:SetPoint("TOP",EncounterJournal,"TOP",650,0)
		local sepr = f:CreateTexture()
		sepr:SetTexture(1,1,1,1)
		sepr:SetWidth(300)
		sepr:SetHeight(1)
		sepr:ClearAllPoints()
		sepr:SetPoint("TOP",journalForgetButton,"BOTTOM",0,-10)
	end
end)


